/* 010113-3.C                                                                */
/* 2001-01-13 programmeerimisolmpiaadi 3. lesande lahendus                 */
/*    ARVUKOLMNURK                                                           */
/* Heno Ivanov                                                               */
/* Testitud: BC++ 3.1, DJGPP 2.8.1                                           */

#define MAXN 100

#include <stdio.h>

/*

Lahenduse idee 

Meid huvitava arvukolmnurga tipp avaldub sama suure Pascali kolmurga ja
meie kolmnurga alumise rea korrutiste summana.

    8              1
  3   5          1   1
1   2   3      1   2   1         ---  1*1 + 2*2 + 1*3 = 8
             1   3   3   1
           1   4   6   4   1
          ...................

Seega taandub lesanne kahe jada paarikaupa korrutiste  maksimaalse ja
minimaalse summa leidmisele. Pascali kolmnurgas esinevad ainult positiivsed
arvud - seega pole vaja vaadelda kahe negatiivse arvu korrutisi.

*/

/* triviaalne sorteerija - sisse viit masiivile ja N  */
void tsort(long *arvud, long N)
{
    long i, j, s;
    for (i = 0; i < N - 1; i++)
        for (j = i; j < N; j++)
            if (arvud[i] > arvud[j]) {
                s = arvud[i];
                arvud[i] = arvud[j];
                arvud[j] = s;
            }
}


int main()
{
    long arvud[MAXN];
    long pas[MAXN];
    FILE *ifile, *ofile;
    long N; /* kolmnurga aluse pikkus */
    long i, j;
    long suurim, vahim;

    /*
       sisendi lugemine 
     */

    printf("lesanne arvukolmnurk. nidislahendus - Heno Ivanov\n");

    ifile = fopen("kolmnurk.sis", "r");
    fscanf(ifile, "%ld", &N);
    for (i = 0; i < N; i++)
	fscanf(ifile, "%ld", &arvud[i]);
    fclose(ifile);

    /*
       sorteerime arvud 
     */

    tsort(arvud, N);

    /*
       esimene rida pascali kolmnurgas 
     */

    for (i = 0; i < N; i++)
	pas[i] = 0;
    pas[0] = 1;

    /*
       lisame N-1 rida
       kuna kolmnurk kasvab "tahapoole"
       siis sisemine tsykkel tagurpidi
     */

    for (j = 0; j < N - 1; j++)
	for (i = N - 1; i > 0; i--)
	    pas[i] = pas[i - 1] + pas[i];

    /*
       sorteerime saadud kordajad 
     */

    tsort(pas, N);

    /*
       suurima vimaliku tipu saamiseks korrutame 
       arvud samas suunas sorteeritud pascali kolmnurgast
       saadud kordajate jadaga

       vhima jaoks aga aga vtame pascali kolmnurga 
       kordajaid vastupidises jrjekorras 
     */

    vahim = 0;
    suurim = 0;

    for (i = 0; i < N; i++) {
	suurim += arvud[i] * pas[i];
	vahim += arvud[i] * pas[N - i - 1];
    }

    /*
       vljastame tulemuse 
     */

    ofile = fopen("kolmnurk.val", "w");
    fprintf(ofile, "%ld\n%ld\n", suurim, vahim);
    fclose(ofile);
    return 0;
}